"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinarySet = void 0;
const object_set_1 = require("./object-set");
class BinarySet extends object_set_1.ObjectSet {
    delete(value) {
        const valueView = getBinaryView(value);
        const scrubbedValues = this._values.filter(item => {
            return !binaryEquals(getBinaryView(item), valueView);
        });
        const numRemoved = this._values.length - scrubbedValues.length;
        this._values = scrubbedValues;
        return numRemoved > 0;
    }
    has(value) {
        const valueView = getBinaryView(value);
        for (const item of this) {
            if (binaryEquals(getBinaryView(item), valueView)) {
                return true;
            }
        }
        return false;
    }
}
exports.BinarySet = BinarySet;
function binaryEquals(a, b) {
    if (a.byteLength !== b.byteLength) {
        return false;
    }
    for (let i = 0; i < a.byteLength; i++) {
        if (a.getUint8(i) !== b.getUint8(i)) {
            return false;
        }
    }
    return true;
}
function getBinaryView(value) {
    return ArrayBuffer.isView(value)
        ? new DataView(value.buffer, value.byteOffset, value.byteLength)
        : new DataView(value);
}
//# sourceMappingURL=binary-set.js.map