"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NumberValueSet = void 0;
const object_set_1 = require("./object-set");
const number_value_1 = require("./number-value");
class NumberValueSet extends object_set_1.ObjectSet {
    add(value) {
        if (typeof value === 'number' || typeof value === 'string') {
            value = new number_value_1.NumberValue(value);
        }
        super.add(value);
        return this;
    }
    delete(value) {
        const valueString = value.toString();
        const scrubbedValues = this._values
            .filter(item => item.toString() !== valueString);
        const numRemoved = this._values.length - scrubbedValues.length;
        this._values = scrubbedValues;
        return numRemoved > 0;
    }
    has(value) {
        const valueString = value.toString();
        for (const item of this) {
            if (item.toString() === valueString) {
                return true;
            }
        }
        return false;
    }
}
exports.NumberValueSet = NumberValueSet;
//# sourceMappingURL=number-value-set.js.map