"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NumberValue = void 0;
const NUMBER_VALUE_TAG = 'DynamoDbNumberValue';
const EXPECTED_TAG = `[object ${NUMBER_VALUE_TAG}]`;
class NumberValue {
    constructor(value) {
        this[Symbol.toStringTag] = NUMBER_VALUE_TAG;
        this.value = value.toString().trim();
    }
    toJSON() {
        return this.valueOf();
    }
    toString() {
        return this.value;
    }
    valueOf() {
        return Number(this.value);
    }
    static isNumberValue(arg) {
        return (typeof NumberValue === 'function' && arg instanceof NumberValue)
            || Object.prototype.toString.call(arg) === EXPECTED_TAG;
    }
}
exports.NumberValue = NumberValue;
//# sourceMappingURL=number-value.js.map